<script lang="ts">
	import queryString from "query-string"
	import { getContext } from "svelte"
	import { browser } from "$app/env"
	import { goto } from "$app/navigation"
	import { page, session } from "$app/stores"
	import type { DataPackage } from "$lib/storage"
	import { AUTH_CONTEXT_KEY } from "$lib/constants"
	import { userProfile } from "$lib/stores"

	$: project = $page.query.get("project")

	let datapackage: DataPackage = null
	let fetchError

	const { gotoLoginIfAnonymous, tokens } = getContext(AUTH_CONTEXT_KEY)
	gotoLoginIfAnonymous($page)
	$: if (browser && $tokens && $userProfile) {
		fetchInitialData($session, $tokens, $userProfile)
	}

	async function fetchInitialData(session, tokens, userProfile) {
		const GitLabStorageAdapter = (await import("$lib/infrastructure/storage-adapter/gitlab")).default
		const storageAdapter = GitLabStorageAdapter.create(session.config, tokens, userProfile)
		// Fetch data package to view
		if (project) {
			try {
				datapackage = await storageAdapter.fetchDataPackage(project)
			} catch (error) {
				console.error(error)
				fetchError = "Could not load data package"
			}
		} else {
			fetchError = "Query string parameter 'project' is missing"
		}
	}

	function handleEdit() {
		goto(
			queryString.stringifyUrl({
				url: "/data-packages/edit",
				query: { project: project },
			})
		)
	}
</script>

<nav aria-label="breadcrumb" class="mb-8">
	<ul class="breadcrumb p-2 rounded bg-gray-100">
		<li class="breadcrumb-item"><a href="/data-packages">Data Packages</a></li>
		<li class="breadcrumb-item" aria-current="page">View</li>
	</ul>
</nav>

{#if fetchError}
	<p>{fetchError}</p>
{:else if datapackage}
	<p>
		Name: {datapackage.name}
		<a class="ml-4 btn btn-primary" href={datapackage.minisiteUrl} rel="external" target="_blank">View Minisite</a>
	</p>
	<p>Description: {datapackage.description}</p>
	<p>Project URL: <a href={datapackage.projectUrl} rel="external" target="_blank">{datapackage.projectUrl}</a></p>
	<ul>
		{#each datapackage.resources as resource}
			<li><a href={resource.url} rel="external" target="_blank">{resource.path}</a></li>
		{/each}
	</ul>
	<div class="my-8">
		<span class="btn btn-primary" href="/data-packages/new" on:click={handleEdit}>Edit Data Package</span>
	</div>
{/if}
